@warnings
@version 2.3
@name SelectFavoritesByItemMC
@script master
setNames; lineOfSet; oFile;
fileOpen = false;
c1..4; sbi;
load: io, what
{

}
save: io, what
{

}
destroy
{
	if(reqisopen())
		reqabort();
}
options
{
	refreshListbox();
	reqbegin("SelectFavoritesByItemMC");
	reqsize(120,190);
	c1 = ctllistbox("Favorites Sets",100,150,"fav_count","fav_names","fav_event");
	c2 = ctlbutton("Refresh",50,"refreshListboxUpdate");
	c3 = ctlbutton("Tag Item to Set",90,"tagSetToItem");
	c4 = ctlcheckbox("SBI",sbi);
	ctlrefresh(c4,"refreshSBI");
	reqresize("resize",50,70,,);
	reqopen();
}
refreshSBI: val
{
	sbi = val;
}
tagSetToItem
{
	selected = Scene().getSelect();
	(n) = getvalue(c1);
	sn = setNames[n];
	for(i=1;i<=selected.size();i++)
		selected[i].setTag(2,sn);
}
resize: w, h
{
	ctlposition(c1,0,1,((w - 80) + 65),((h - 80) + 38));
	ctlposition(c2,0,h - 40);
	ctlposition(c3,0,h - 19);
	ctlposition(c4,55,h - 40);
}
create
{
	setdesc("Select Favorites Sets By Item");
	sbi = integer(recall("SBI",0));
}
process: event, command
{
	if(event == COMMAND)
	{
		if(sbi)
		{
			if(strleft(command,10) == "SelectItem" || strleft(command,14) == "AddToSelection" || strleft(command,12) == "SelectByName")
			{
				ndx[1] = nil;
				k = 0;
				selected = Scene().getSelect();
				for(i=1;i<=selected.size();i++)
				{
					sn = selected[i].getTag(2);
					for(j=1;j<=setNames.size();j++)
					{
						if(setNames[j] == sn)
							ndx[++k] = j;
					}
					if(ndx[1])
					{
						sbi = false;
						fav_event(ndx);
						sbi = true;
						AddToSelection(selected[1].id);
					}
				}
			}
		}
	}
}
fav_count { return(setNames.size()); }
fav_names: ndx { return(setNames[ndx]); }

fav_event: ndx
{
	if(!sbi)
	{
		for(j=1;j<=ndx.size();j++)
		{
			n = ndx[j];
			return if(!lineOfSet[n]);
			oFile.line(lineOfSet[n]);
			line = oFile.read();
			(,a) = parse(" ",line);
			numItems = integer(a);
			for(i=1;i<=numItems;i++)
			{
				line = oFile.read();
				(,a) = parse(" ",line);
				itemID = string(a);
				if(i == 1 && j == 1)
					ciString = string("SelectItem ",itemID);
				else
					ciString = string("AddToSelection ",itemID);
				CommandInput(ciString);
			}
		}
	}
}

refreshListboxUpdate
{
	refreshListbox();
	requpdate();
}
openFile
{
	temp = string("c:/tempSFMC.lws");
	SaveSceneCopy(temp);
	oFile = File(temp,"r+");
	fileOpen = true;
}
closeFile
{
	oFile.close();
	filedelete("c:/tempSFMC.lws");
	fileOpen = false;
}

refreshListbox
{
	for(i=1;i<=setNames.size();i++)
	{
		setNames[i] = nil;
		lineOfSet[i] = nil;
	}
	if(fileOpen)
		closeFile();
	openFile();
	s = 0;
	for(i=1;!oFile.eof();i++)
	{
		line = oFile.read();
		if(strleft(line,16) == "ItemSelectionSet")
		{
			b = line.size() - 16;
			a = strsub(line,18,b);
			setNames[++s] = a;
			lineOfSet[s] = oFile.line();
		}		
	}
}
