@warnings
@version 2.3
@name SelectFavoritesMC
@script master
setNames; lineOfSet; oFile;
fileOpen = false;
c1; c2; c3;
iomenu;
chooseSet;
defaultff;
destroy
{
	if(reqisopen())
		reqabort();
}
options
{
	refreshListbox();
	reqbegin("SelectFavoritesMC");
	reqsize(120,190);
	c1 = ctllistbox("Favorites Sets",100,150,"fav_count","fav_names","fav_event");
	c2 = ctlbutton("Refresh",50,"refreshListboxUpdate");
	c3 = ctlmenu("I/O",iomenu,"iomenu_sel");
	reqresize("resize",50,70,,);
	reqopen();
}
resize: w, h
{
	ctlposition(c1,0,1,((w - 80) + 65),((h - 80) + 59));
	ctlposition(c2,0,h - 19);
	ctlposition(c3,49,h - 19,55);
}
create
{
	setdesc("Select Favorites Sets");
	iomenu[1] = "Save Scene Favorites";
	iomenu[2] = "Load Scene Favorites";
	chooseset[1] = nil;
	defaultff = recall("SFMC_DEFAULTFF",getdir(SCENESDIR));
}

fav_count { return(setNames.size()); }
fav_names: ndx { return(setNames[ndx]); }

iomenu_sel: ndx
{
	if(ndx == 1)
		saveFavorites();
	if(ndx == 2)
		loadFavorites();
}

saveFavorites
{
	reqbegin("Save Favorites");

	d1 = ctlfilename("File Out",defaultff,75,0);
	d2 = ctlchoice("Save",1,@"All Sets","Selected Only"@);

	if(reqpost())
	{
		favfile = getvalue(d1);
		savechoice = getvalue(d2);

		if(favfile == nil)
			return;

		ff = File(favfile,"w+");

		if(!ff)
			error("Error opening file.");

		if(savechoice == 1)
		{
			for(i=1;i<=setNames.size();i++)
				ndx[i] = i;
		}
		if(savechoice == 2)
		{
			ndx = getvalue(c1);
			if(ndx[1] == nil)
				error("No set has been selected.");
		}
		for(j=1;j<=ndx.size();j++)
		{
			n = ndx[j];
			oFile.line(lineOfSet[n]);
			line = oFile.read();
			(,a) = parse(" ",line);
			numItems = integer(a);
			str = string("Set-=-=-",setNames[n],"-=-=-",numItems);
			ff.writeln(str);
			for(i=1;i<=numItems;i++)
			{
				line = oFile.read();
				(,a) = parse(" ",line);
				itemID = string(a);
				ciString = string("SelectItem ",itemID);
				CommandInput(ciString);
				thisSelect = Scene().firstSelect();

				ts = nil;
				if(thisSelect.genus == MESH)
					thisGenus = "MESH";
				if(thisSelect.genus == BONE)
				{
					thisGenus = "BONE";
					ts = thisSelect.parent;
				
					while(ts.genus != MESH)
						ts = ts.parent;
				}
				if(thisSelect.genus == LIGHT)
					thisGenus = "LIGHT";
				if(thisSelect.genus == CAMERA)
					thisGenus = "CAMERA";

				if(ts != nil)
					str = string(thisGenus,"-=-=-",Scene().firstSelect().name,"-=-=-",ts.name);
				else
					str = string(thisGenus,"-=-=-",Scene().firstSelect().name,"-=-=-");
				ff.writeln(str);
			
			}
		}
	}
	
	reqabort();
	options();
	
}
loadFavorites
{
	selfScene = fullpath(Scene().filename);
	ndx = getvalue(c1);
	reqabort();

	reqbegin("Load Favorites");

	e1 = ctlfilename("File In",defaultff,75,1);
	e2 = ctlfilename("Scene File Out",selfScene,75,0);
	e3 = ctlchoice("Load",1,@"All Sets","Select After Open"@);

	if(reqpost())
	{
		favfile = getvalue(e1);
		outfile = getvalue(e2);
		savechoice = getvalue(e3);

	
		ff = File(favfile,"r+");
		fout = File(outfile,"w+");

		if(!ff)
			error("Error reading input file.");
		if(!fout)
			error("Error opening output file. File may be in use.");

		SaveSceneCopy(outfile);

		fout.reopen("a");

		if(savechoice == 1)
			processLoadFavorites(ff,fout,nil);
		if(savechoice == 2)
		{
			c = 0;
			reqabort();
			while(!ff.eof())
			{
				line = ff.read();
				pl = parse("-=-=-",line);
				if(pl[1] == "Set")
					chooseSet[++c] = pl[2];
			}
			ff.rewind();
			reqbegin("Choose Selection Sets");
			f1 = ctllistbox("Selection Sets",200,200,"chooseset_count","chooseset_names");
			return if(!reqpost());
			chosensets = getvalue(f1);
			processLoadFavorites(ff,fout,chosensets);	
		}
	}
	reqabort();
	options();
}
chooseset_count
{
	if(chooseSet[1] != nil)
		return(chooseSet.size());
	else
		return(0);
}
chooseset_names: ndx
{
	if(ndx <= chooseSet.size())
		return(chooseSet[ndx]);
}
processLoadFavorites: ff, fout, chosensets
{
	while(!ff.eof())
	{
		ffline = ff.read();
		pl = parse("-=-=-",ffline);

		if(pl[1] == "Set") // see a Set
		{
			ffsetname = pl[2];
			if(chosensets != nil)
			{
				// check if this set is chosen
				foundset = false;
				for(j=1;j<=chosensets.size();j++)
				{
					cs = chosensets[j];
					if(ffsetname == chooseSet[cs])
						foundset = true;
				}
				if(foundset == false)
					continue;
			}
			ffnumItems = integer(pl[3]);
			str = string("ItemSelectionSet ",ffsetname);
			fout.writeln(str);
			str = string("NumItems ",ffnumItems);

			fout.writeln(str);

			for(i=1;i<=ffnumItems;i++)
			{
				ffline = ff.read();
				plf = parse("-=-=-",ffline);
				if(plf[1] == "BONE")	
				{
					SelectByName(plf[3]);
					EditBones();
					SelectByName(plf[2]);
				}
				else
					SelectByName(plf[2]);
				RefreshNow();
				thisID = string(hex(Scene().firstSelect().id));
				thisIDString = strsub(thisID,3,thisID.size() - 2);
				str = string("Item ",thisIDString);
				fout.writeln(str);
			}
		}
	}
}

fav_event: ndx
{
	for(j=1;j<=ndx.size();j++)
	{
		n = ndx[j];
		oFile.line(lineOfSet[n]);
		line = oFile.read();
		(,a) = parse(" ",line);
		numItems = integer(a);
		for(i=1;i<=numItems;i++)
		{
			line = oFile.read();
			(,a) = parse(" ",line);
			itemID = string(a);
			if(i == 1 && j == 1)
				ciString = string("SelectItem ",itemID);
			else
				ciString = string("AddToSelection ",itemID);
			CommandInput(ciString);
		}
	}
}

refreshListboxUpdate
{
	refreshListbox();
	requpdate();
}
openFile
{
	temp = string("c:/tempSFMC.lws");
	SaveSceneCopy(temp);
	oFile = File(temp,"r+");
	fileOpen = true;
}
closeFile
{
	oFile.close();
	filedelete("c:/tempSFMC.lws");
	fileOpen = false;
}

refreshListbox
{
	for(i=1;i<=setNames.size();i++)
	{
		setNames[i] = nil;
		lineOfSet[i] = nil;
	}
	if(fileOpen)
		closeFile();
	openFile();
	s = 0;
	for(i=1;!oFile.eof();i++)
	{
		line = oFile.read();
		if(strleft(line,16) == "ItemSelectionSet")
		{
			b = line.size() - 16;
			a = strsub(line,18,b);
			setNames[++s] = a;
			lineOfSet[s] = oFile.line();
		}		
	}
}
